//
//  AccelBump.h
//  AccelBump
//
//  Created by manuMohan on 1/3/13.
//  Copyright (c) 2013 manuMohan. All rights reserved.
//

#import <Foundation/Foundation.h>

#define serverIpAddress @""
#define serverPort 5000

typedef unsigned long long BumpChannel;
typedef enum{
    BUMP_EVENT_MATCH,
    BUMP_EVENT_NO_MATCH
}bump_event;

typedef enum {
    VIBRATION_ON,
    VIBRATION_OFF
}bump_vibration;

//event blocks for bump actions
typedef void (^BumpEventBlock)(bump_event event);
typedef void (^BumpMatchBlock)(BumpChannel channel);
typedef void (^BumpChannelLockedBlock)(BumpChannel channel);//write send data codes in this block
typedef void (^BumpDataReceivedBlock)(NSData *data, BumpChannel channel);
typedef void (^BumpConnectionStateChangedBlock) (BOOL connected);

//optional blocks
@interface AccelBump : NSObject{
}
//return a singleton instance of the AccelBump Class
+ (AccelBump *)sharedInstance;

- (void)connect;
- (void)disconnect;

/**conf methods */
+ (void)setApiKey:(NSString *)apiKey andUserName:(NSString *)userName;
//Set bump event block, handle different bump events
- (void)setBumpEventBlock:(BumpEventBlock)bumpEventBlock;
//Set bump match block
- (void)setBumpMatchBlock:(BumpMatchBlock)bumpMatchBlock;
//Set bump channel locked block
- (void)setBumpChannelLockedBlock:(BumpChannelLockedBlock)bumpChannelLockedBlock;
//Set the data received block, handle the data received
- (void)setBumpDataReceivedBlock:(BumpDataReceivedBlock)bumpDataReceivedBlock;
//set the connection state changed block, handle any connection changes
- (void)setBumpConnectionStateChangedBlock:(BumpConnectionStateChangedBlock)bumpConnectionStateChangedBlock;

/**optional methods*/
//Set bump vibration to on or off
- (void)setBumpVibration:(bump_vibration)vibration;
//retrieve the user name for channel
- (NSString *)userNameForChannel:(BumpChannel)channel;

//Send data to a channel 
- (void)sendData:(NSData *)data toChannel:(BumpChannel)channel;

//simulate a bump action without accelerometer
- (void)simulateBump;
@end
