//
//  AccelManager.m
//  AccelBump
//
//  Created by manuMohan on 1/7/13.
//  Copyright (c) 2013 manuMohan. All rights reserved.
//

#import "BumpManager.h"

static BumpManager *sharedBumpManager = nil;

@interface BumpManager(){
    CMAccelerometerHandler  accelHandler;
}

@end
@implementation BumpManager

- (id)init{
    self = [super init];
    if(self != nil){
        motionManager = [CMMotionManager new];
    }
    return self;
}

+(BumpManager *)sharedInstance {
    if(sharedBumpManager == nil){
        sharedBumpManager = [[BumpManager alloc] init];
    }
    return sharedBumpManager;
}

- (void)listenForAccelShakeWithHandler:(BumpHandler)bumpHandler{
    bumpHandler_ = bumpHandler;
    __block BumpManager *blockSafeSelf = self;
    accelHandler = ^(CMAccelerometerData *accelerometerData, NSError *error){
        [blockSafeSelf processAccelDataAndNotifyBump:accelerometerData];
    };
    motionManager.accelerometerUpdateInterval = 0.1;
    NSOperationQueue *accelReadQueue = [[NSOperationQueue alloc] init];
    [motionManager startAccelerometerUpdatesToQueue:accelReadQueue withHandler:accelHandler];
    
}

//process if the accel data,determine if there is a bump
- (void)processAccelDataAndNotifyBump:(CMAccelerometerData *)data{
    if(data.acceleration.x >= 0.3){
        bumpHandler_(YES);
    }else if(data.acceleration.y >= 0.3){
        bumpHandler_(YES);
    }else if(data.acceleration.z >= 0.3){
        bumpHandler_(YES);
    }
    bumpHandler_(NO);
}

@end
