//
//  LocationManager.m
//  AccelBump
//
//  Created by manuMohan on 1/7/13.
//  Copyright (c) 2013 manuMohan. All rights reserved.
//

#import "LocationManager.h"

static LocationManager *sharedLocationManager = nil;

@implementation LocationManager

- (id)init{
    self = [super init];
    if(self != nil){
        locationManager = [[CLLocationManager alloc] init];
        
        locationManager.distanceFilter = kCLDistanceFilterNone;
        locationManager.desiredAccuracy = kCLLocationAccuracyBest;
        
    }
    return self;
}

+ (LocationManager *)sharedInstance{
    if(sharedLocationManager == nil){
        sharedLocationManager = [[LocationManager alloc] init];
    }
    return sharedLocationManager;
}

- (void)start{
    [locationManager startUpdatingLocation];
}
- (void)stop{
    [locationManager stopUpdatingLocation];
}
- (CLLocation *)getCurrentLocation{
    return [locationManager location];
}
@end
