//
//  NetworkManager.h
//  AccelBump
//
//  Created by manuMohan on 1/7/13.
//  Copyright (c) 2013 manuMohan. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreFoundation/CoreFoundation.h>

typedef void (^DataReceivedBlock) (NSString *data);

@interface NetworkManager : NSObject<NSStreamDelegate>

//Connect to the bump server
- (void)connectToServer;

//Disconnect from the bump server
- (void)disconnectServer;

//Send data to server
- (void)writeToServer:(NSString *)data;

//Set the data handler block
- (void)setDataReceivedBlock:(DataReceivedBlock)dataReceivedBlock;


+ (NetworkManager *)sharedInstance;
@end
