//
//  UtilsManager.m
//  AccelBump
//
//  Created by manuMohan on 1/22/13.
//  Copyright (c) 2013 manuMohan. All rights reserved.
//

#import "UtilsManager.h"
#import <SBJson/SBJson.h>
static UtilsManager *sharedUtilsManager = nil;
@implementation UtilsManager

- (void)setApiKey:(NSString *)apiKey{
   apiKey_ = apiKey;
}

+ (UtilsManager*)sharedInstance{
    if(sharedUtilsManager == nil){
        sharedUtilsManager = [[UtilsManager alloc] init];
    }
    return sharedUtilsManager;
}
#pragma mark - public methods
- (NSString *)getBumpMessageToServerWithLocation:(CLLocation *)location{
    NSMutableDictionary *messageDictionary = [[NSMutableDictionary alloc] init];
    [messageDictionary setValue:apiKey_ forKey:@"apikey"];
    [messageDictionary setValue:[NSString stringWithFormat:@"%f",location.coordinate.latitude] forKey:@"latitude"];
    [messageDictionary setValue:[NSString stringWithFormat:@"%f",location.coordinate.longitude] forKey:@"longitude"];
    SBJsonWriter *writer = [[SBJsonWriter alloc] init];
    NSString *messageToServer = [writer stringWithObject:messageDictionary];
    return messageToServer;
}
- (NSString *)getBumpMessageWithContent:(NSData *)data forChannel:(BumpChannel)channel{
    NSMutableDictionary *messageDictionary = [[NSMutableDictionary alloc] init];
    [messageDictionary setValue:apiKey_ forKey:@"apikey"];
    [messageDictionary setValue:[NSString stringWithFormat:@"%@",data] forKey:@"content"];
    [messageDictionary setValue:[NSString stringWithFormat:@"%llu",channel] forKey:@"channel"];
    SBJsonWriter *writer = [[SBJsonWriter alloc] init];
    NSString *messageToServer = [writer stringWithObject:messageDictionary];
    return messageToServer;
}
@end
